#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>


void usage(void)
{
  printf("Unknown option, usage()\n");
}

int arg_int(void)
{
  if (isdigit(optarg[0])) return atoi(optarg);
   printf("option -%c: invalid int value\n", optopt);
   return 0;
   }

char *arg_str(void)
{
  if (isalnum(optarg[0])) return optarg;
   printf("option -%c: invalid string value\n", optopt);
   return "!!!";
   }

int main(int argc,char *argv[])
{
 

  int bflag,fd,ov, ch;
     char c;

     opterr = 0;

     bflag = fd = ov = 0;

   while (optind < argc) {
     if ((ch = getopt(argc, argv, ":b:f:o:")) != -1) {

         printf("ch=%c, optopt=%c, argc=%d, optind=%d, optarg=%x,  bflag=%d, fd=%d, ov=%d\n",
		ch, optopt, argc, optind, optarg,  bflag, fd, ov);
         switch (ch) {
            case 'b':
	       printf("b: arg=%d\n", bflag = arg_int());
                break;
            case 'f':
	       printf("f: arg=>%s<\n", arg_str());
               break;
            case 'o':
	       printf("o: ov=%d\n", ov = arg_int());
               break;

            case ':':
               if (optopt != 'o') {
	          printf("option -%c: missing value\n", optopt);
                  }
               break;
            case '?':
            default:
               usage();
               }
            }
         else {
	   printf("got -1, optind=%d, argv[optind]=>%s<\n",
		  optind, argv[optind]);
	   ++optind;
            }

       printf("ch=%c, argc=%d, optind=%d, optarg=%x,  bflag=%d, fd=%d\n\n",
	    ch, argc, optind, optarg,  bflag, fd);
        }
     argc -= optind;
     argv += optind;

   }
