#!/usr/local/bin/ruby

# ./fix-cpr-date.rb *.c 2004 2006
#   Leave out dates to search for Copyright

dir = ARGV[0];  old = ARGV[1];  new = ARGV[2]

oldp = "#{old} by "
newr = "#{new} by "
test = old.nil? || new.nil?

puts "dir=#{dir}, oldp=#{oldp}, newr=#{newr}, test=#{test}"

Dir.glob(dir) { |fn|
   puts "fn=#{fn}"

   if test then ifn = fn
   else
      File.rename(fn, "#{fn}\~")
      out = File.open(fn, "w")
      ifn = "#{fn}\~"
      end

  File.open(ifn) do |file|
      file.each_line { |line|
         if line =~ /Copyright.*Nevil/ 
            if test then puts line
            else line = line.sub(oldp, newr)
               end
            end
         if !test
            out.puts line 
            end
         }

      end
   }
